#!/usr/bin/perl -w

$inbody = $htmlonly = $ebkonly = 0;
$title = '';
$body = '';

while (<>) {
  chomp;

  if (m{<title>(.*)</title>}) {
    $title = $1;
  }
  if (m{<body>}) {
    $inbody = 1;
  }

  if (m{ENDHTMLONLY}) {
    $htmlonly = 0;
  }
  elsif (m{HTMLONLY}) {
    $htmlonly = 1;
  }
  elsif (m{ENDEBKONLY}) {
    $ebkonly = 0;
  }
  elsif (m{EBKONLY}) {
    $ebkonly = 1;
  }
  elsif ($inbody && $ebkonly) {
    $body .= $_ . "\n";
  }
  elsif ($inbody && !$htmlonly) {
    s{<br[^>]*>}      {&NL;}g;
    s{<td[^>]*>}      {&NL;}g;
    s{</?table[^>]*>} {&NL;}g;
    s{</?tr[^>]*>}    {&NL;}g;
    s{</?p[^>]*>}     {&NL;}g;
    s{</?dl[^>]*>}    {&NL;}g;
    s{</?dt[^>]*>}    {&NL;}g;
    s{<dd[^>]*>}      {&NL;&#8199;}g;
    s{</dd[^>]*>}     {&NL;}g;
    s{^[ \t]*}        { }g;

    s{<sup>-1</sup>}      {&#61445;}g;
    s{<sup>2</sup>}       {&#178;}g;
    s{<sup>&ndash;</sup>} {&#8315;}g;

    s{&[lr]squo;} {'}g;
    s{&[lr]dquo;} {"}g;
    s{&times;}    {&#215;}g;
    s{&theta;}    {&#952;}g;
    s{&le;}       {&#8804;}g;
    s{&ge;}       {&#8805;}g;
    s{&ne;}       {&#8800;}g;
    s{&copy;}     {&#169;}g;
    s{-}          {&#8208;}g;
    s{&ndash;}    {-}g;

    s{<h2[^>]*>(.*)</h2>} {qq{&NL;-=section title="$1" /=-} . uc $1 . "&NL;"}eg;
    s{<h3[^>]*>(.*)</h3>} {qq{&NL;-=section title="&#8199;$1" /=-} . uc $1 . "&NL;"}eg;

    s{<[^>]*>} {}g;
    s{-=}      {<}g;
    s{=-}      {>}g;

    $body .= $_;
  }
}

$body =~ s{ +}           { }g;
$body =~ s{(\.[()"']*) } {$1  }g;
$body =~ s{ *&NL; *}     {\n}g;
$body =~ s{ *&#8199; *}  {&#8199;}g;
$body =~ s{\n\n\n+}      {\n\n}g;
$body =~ s{^ }           {};
$body =~ s{\n*$}         {};
$body =~ s{&nbsp;}       { }g;

print <<EOF
<?xml version="1.0" encoding="UTF-8"?>
<flashbook>
<title>$title</title>
<hyphenation enabled="1" lang="en_US"/>
<body>$body</body>
</flashbook>
EOF

