#!/usr/bin/perl -w

$nvalues = q{ adeilnorst};
$bvalues = q{[!"#$%&'()*+,-./};
$cvalues = q{?>=<;:9876543210};
$dvalues = q{@ABCDEFGHIJKLMNO};
$evalues = q{_z]\~ZYXWVUTSRQP};
$fvalues = q{^bcfghjkmpquvwxy};

sub pack_com_string {
  my $text = shift;
  my $hex = '';
  my $data = '';
  my $v;

  foreach my $c (split //, $text) {
    if (($v = index $nvalues, $c) != -1) {
      $hex .= sprintf '%X', $v;
    }
    elsif (($v = index $bvalues, $c) != -1) {
      $hex .= sprintf 'B%X', $v;
    }
    elsif (($v = index $cvalues, $c) != -1) {
      $hex .= sprintf 'C%X', $v;
    }
    elsif (($v = index $dvalues, $c) != -1) {
      $hex .= sprintf 'D%X', $v;
    }
    elsif (($v = index $evalues, $c) != -1) {
      $hex .= sprintf 'E%X', $v;
    }
    elsif (($v = index $fvalues, $c) != -1) {
      $hex .= sprintf 'F%X', $v;
    }
  }

  $hex .= '0' if ((length $hex) % 2);
  $hex =~ s/([0-9A-F][0-9A-F]?)/0$1h,/g;
  $hex =~ s/,$//;
  return $hex;
}

@cwidth = ( 1, 2, 4, 6, 6, 4, 5, 2, 3, 3, 6, 4, 3, 4, 2, 4, 4, 4,
	    4, 4, 4, 4, 4, 4, 4, 4, 2, 3, 4, 4, 4, 4, 6, 4, 4, 4,
	    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
	    4, 4, 4, 4, 4, 3, 4, 3, 4, 4, 3, 4, 4, 4, 4, 4, 3, 4,
	    4, 2, 4, 4, 3, 6, 4, 4, 4, 4, 4, 3, 3, 4, 4, 6, 4, 4,
	    5, 4, 2, 4, 5 );

sub str_width {
  my $text = shift;
  my $width = 0;
  foreach my $c (unpack 'c*', $text) {
    if ($c > 31 && $c < 127) {
      $width += $cwidth[$c - 32];
    }
  }
  return $width;
}

@lines = ();
$maxwidth = 0;

while (<>) {
  chomp;
  push @lines, $_;

  s/#/AAAA/g;
  s/&/AAAAAAAA/g;
  s/_/AAAAAAAAAAAAAAAA/g;

  $w = str_width($_) + 7;
  if ($w > $maxwidth) {
    $maxwidth = $w;
  }
}

print " db ", (scalar @lines), ", ", $maxwidth, "\n";
foreach $line (@lines) {
  $hexstr = pack_com_string($line);
  @hexbytes = split m{,}, $hexstr;

  print " db ", (scalar @hexbytes), ", ", $hexstr;
  print " ; ", $line, "\n";
}
