#!/usr/bin/perl -w

use Digest::MD5 qw(md5_hex);

%exports = ();

open DAT, "plugapi.dat" or die "can't open plugapi.dat";
while (<DAT>) {
  if (/^(\w+)/) {
    $exports{$1} = '';
  }
}
close DAT;

open LST, "mimas.lst" or die "can't open mimas.lst";
while (<LST>) {
  if (/^([0-9A-F]{8})  (\w+)$/) {
    if (defined $exports{$2}) {
      $exports{$2} = $1 . 'h';
    }
  }
}
close LST;

$abistr = '';
foreach $sym (sort keys %exports) {
  die "$sym not defined" if $exports{$sym} eq '';
  $abistr .= "$sym=$exports{$sym}+";
}

%oldexports = ();

if (open INC, "plugapi.inc") {
  while (<INC>) {
    if (/^(\w+) equ (\w+)/) {
      if ($1 ne 'PLUGIN_ABI_CHECKSUM') {
        $oldexports{$1} = $2;
      }
    }
  }
  close INC;
}

$oldabistr = '';
foreach $sym (sort keys %oldexports) {
  $oldabistr .= "$sym=$oldexports{$sym}+";
}

if ($abistr ne $oldabistr) {
  open INC, ">plugapi.inc" or die "can't open plugapi.inc";
  print INC "; AUTOMATICALLY GENERATED - DO NOT EDIT\n\n";
  print INC "  ifdef MIMAS_PLUGIN\n";
  foreach $sym (sort keys %exports) {
    print INC "$sym equ $exports{$sym}\n";
  }
  print INC "  endif\n\n";

  $sum = '0' . uc substr(md5_hex($abistr), 0, 4) . 'h';
  print INC "PLUGIN_ABI_CHECKSUM equ $sum\n";
  close INC;

  print "plugapi.inc updated, new checksum = $sum\n";
}

