#!/usr/bin/perl -w

$prevlnum = -1;
$subflnum = -1;
$subfnlines = -1;

$total0 = $total1 = 0;

sub nlines {
  my $fname = shift;
  my $n = 0;

  open F, $fname or die "can't open $fname: $!";
  $n++ while (<F>);
  close F;
  return $n;
}

print "File               Size  Start  End\n";
print "-------------------------------------\n";

while (<>) {
  chomp;
  if (/^([1-9][0-9]*)\s+0*([0-9A-Fa-f]+)\s+(.*)/) {
    $lnum = $1;
    $addr = hex($2);
    $text = $3;

    if ($lnum == $subflnum + 1
	&& ($prevlnum == $subfnlines || $prevlnum == $subfnlines + 1)) {
      printf '%-16s  %5d  %05X  %05X',
	$subfname, $addr - $subfaddr,  $subfaddr, $addr;
      print "\n";
      undef $subfname;
      $subflnum = -1;
    }

    if ($text =~ /^include "(.*\.asm)"/) {
      if (defined($subfname)) {
	print "warning: $1 nested within $subfname\n";
      }
      $subfname = $1;
      $subfnlines = nlines($subfname);
      $subflnum = $lnum;
      $subfaddr = $addr;
    }

    if ($text =~ /^org/) {
      undef $prevaddr;
    }
    else {
      if (defined($prevaddr)) {
	if ($prevaddr >= 0x10000) {
	  $total1 += $addr - $prevaddr;
	}
	elsif ($prevaddr >= 0x4000 && $prevaddr < 0x8000) {
	  $total0 += $addr - $prevaddr;
	}
      }
      $prevaddr = $addr;
    }

    $prevlnum = $lnum;
  }
}

$total1s = $total1 + 96;

print "\nTOTAL: page 0 = $total0, page 1 = $total1s ($total1 without sig)\n\n";
