/*
 * Mimas conversion tools
 *
 * Copyright (C) 2010 Benjamin Moody
 *
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

typedef struct _ti8x_var_entry {
  unsigned char type;
  unsigned char archived;
  char name[9];
  unsigned int length;
  unsigned int length_a;
  unsigned char *data;
} ti8x_var_entry;

typedef struct _ti8x_file {
  char *name;
  int num_vars;
  ti8x_var_entry **vars;
} ti8x_file;

ti8x_file *ti8x_file_new(const char *name);
void ti8x_file_free(ti8x_file *f);
ti8x_var_entry *ti8x_file_add_var(ti8x_file *f,
				  unsigned int type,
				  const char *name,
				  int archived);
void ti8x_var_append_data(ti8x_var_entry *var,
			  const unsigned char *data,
			  unsigned int length);
int ti8x_file_write(FILE *outf, ti8x_file *f);
